#include "param.h"

float4   cnt    : register(c0);
sampler  t0     : register(s0);
sampler  t1     : register(s1);

float map(float3 p) {
  float t = 1000;
  float2 k = float2(0.001, 0);
  float4 o = 0;
  p.xz += cnt.x * 500;
  o += tex2D(t1, (p.xz / 2560) + k.xy);
  /*
  o += tex2D(t1, (p.xz / 2560) - k.xy);
  o += tex2D(t1, (p.xz / 2560) + k.yx);
  o += tex2D(t1, (p.xz / 2560) - k.yx);
  o /= 4;
  */
  float hunya = cos(p.z * 0.005) + cos(p.x * 0.005);
  t = min(dot( float3(0, 1, 0), p) - o.x * 10 + hunya * 200, t);
  return t;
}

float2 rot(float2 d, float a) {
  return float2(cos(a) * d.x - sin(a) * d.y, sin(a) * d.x + cos(a) * d.y);
}

float4 ps_main(float2 vp : vpos) : color {
  float3 d    = normalize(float3(-vp + float2(SCRX_H, SCRY_H), SCRY_H)/SCRY_H);
  float  angle = 0.8;
  d.yz = rot(d.yz, angle);
  float3 pos    = float3(0, 1500, -5);
  float3 ro     = pos;
  
  //go
  for(int i = 0 ; i < 100; i++, pos += map(pos) * d * 0.75 );
  return float4(length(pos - ro ) * 0.0001 + map(pos + normalize(float3(1,1,1)) * 0.5) + d.xyz * 0.2, 1);
  //return length(pos - ro ) * 0.001;
}

float4 ps_main_f(float2 vp : vpos, float2 uv : texcoord0) : color {
  float4 argb = tex2D(t1, uv) * 0.1;
  float2 d = float2(0.0001, 0);
  argb += tex2D(t0, uv + d.xy);
  argb += tex2D(t0, uv - d.xy);
  argb += tex2D(t0, uv + d.yx);
  argb += tex2D(t0, uv - d.yx);
  return argb / 5;
}


